#include "cuddInt.h"
#include "message.h"

static int DdWorkQueueResize(DdManager *manager);

int DdWorkQueuePush(DdManager *manager,int op,int index,int from_process,
DdNodePar f,DdNodePar g,DdNodePar h,DdCallTreeNode caller)
{
  DdWork *w;
  if(manager->WorkQueue.StackPointer==manager->WorkQueue.Size)
    {
      if(DdWorkQueueResize(manager)==0)
	return(0);
    }

  if(manager->WorkQueue.StackPointer>0 &&
     manager->WorkQueue.Stack[manager->WorkQueue.StackPointer-1].index>index)
    {
      /* copy top element and write new one down in the stack */
      w=&manager->WorkQueue.Stack[manager->WorkQueue.StackPointer-1];
      manager->WorkQueue.Stack[manager->WorkQueue.StackPointer++]=*w;
    }
  else
     w=&manager->WorkQueue.Stack[manager->WorkQueue.StackPointer++];

  w->op=op;
  w->index=index;
  w->FromProcess=from_process;
  w->f=f;
  w->g=g;
  w->h=h;
  w->caller=caller;
  return(1);
}

int DdWorkQueuePop(DdManager *manager,int *op,int *index,int *from_process,
DdNodePar *f,DdNodePar *g,DdNodePar *h,DdCallTreeNode *caller)
{
  DdWork *w;
  if(manager->WorkQueue.StackPointer==0)
    return(-1);
  w=&manager->WorkQueue.Stack[--manager->WorkQueue.StackPointer];
  *op=w->op;
  *index=w->index;
  *from_process=w->FromProcess;
  *f=w->f;
  *g=w->g;
  *h=w->h;
  *caller=w->caller;

  return(manager->WorkQueue.StackPointer);
}

int DdWorkQueueCreate(DdManager *manager)
{
  DdWorkQueue *Q;
  Q=&manager->WorkQueue;
  Q->Size=DD_WORK_QUEUE_SIZE;
  Q->Stack=ALLOC(DdWork,DD_WORK_QUEUE_SIZE);
  if(Q->Stack==NULL) return(0);
  manager->memused += sizeof(DdWork) * DD_WORK_QUEUE_SIZE;
  Q->StackPointer=0;
  return(1);
}

int DdWorkQueueResize(DdManager *manager)
{
  DdWork *newStack;
  int i,oldSize;
  
  oldSize=manager->WorkQueue.Size;
  manager->WorkQueue.Size*=DD_WORK_QUEUE_GROWTH;
  newStack=ALLOC(DdWork,manager->WorkQueue.Size);
  if(newStack==NULL)
    {
      manager->WorkQueue.Size=oldSize;
      return(0);
    }
  for(i=0;i<oldSize;i++)
    newStack[i]=manager->WorkQueue.Stack[i];
  FREE(manager->WorkQueue.Stack);
  manager->WorkQueue.Stack=newStack;
  manager->memused = sizeof(DdWork) * (manager->CallTree.Size-oldSize);
  return(1);
}




