#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cuddInt.h"
#include "pvm3.h"

struct timeval start,end,comp={0,0};
struct timezone tzp;

#define comp_start()  gettimeofday(&start,&tzp) 

void comp_end()
{
  gettimeofday(&end,&tzp);
  comp.tv_sec+=end.tv_sec-start.tv_sec;
  comp.tv_usec+=end.tv_usec-start.tv_usec;
}

#define BITS 5
#define VARS 20 /* 2^BITS */

#define send_nor(man,f,g,id) DdMessageSend2(man,CUDD_BDD_AND,ddMin(f.index,g.index),0,Cudd_NotPar(f),Cudd_NotPar(g),id);

#define send_and(man,f,g,id) DdMessageSend2(man,CUDD_BDD_AND,ddMin(f.index,g.index),0,f,g,id);

void main()
{
  DdManager *manager;
  DdNode *g[VARS], *a[VARS],*b[VARS],*m[BITS],*f[VARS],*tmp[1<<BITS];
  int i,j,index;
  int n,k;

  printf("start\n");

  manager = Cudd_Init(2*VARS+BITS,0,CUDD_UNIQUE_SLOTS,CUDD_MAX_CACHE_SIZE,CUDD_MAX_CACHE_SIZE);
  for(i=0;i<VARS;i++)
    {
      a[i]=Cudd_bddIthVar(manager,2*i);
      b[i]=Cudd_bddIthVar(manager,2*i+1);
    }
  for(i=0;i<VARS;i++)
    {
      for(j=0;j<VARS;j++)
	{
	  tmp[j]=Cudd_bddOr(manager,a[j],b[(i+j)%VARS]);
	}
      for(j=VARS;j<1<<BITS;j++)
	tmp[j]=Cudd_ReadOne(manager);

      for(j=BITS-1;j>0;j--)
	{
	  n=(1<<j);
	  for(k=0; k<n; k++)
	    {
	      tmp[k]=Cudd_bddAnd(manager,tmp[k],tmp[k+n]);
	    }
	}
      g[i]=tmp[0];
      f[i]=tmp[1];
      printf("%d\n",manager->allocated);
    }

  /*  DdReassignLevels(manager); */
  
  comp_start();
  for(i=0;i<VARS;i++)
    {
      Cudd_bddAnd(manager,g[i],f[i]);
    }
  comp_end();

  printf("compute time %f\n",(float)comp.tv_sec+(float)comp.tv_usec/1000000);
  printf("cache collitions %d\n",manager->cachecollisions);
  Cudd_Quit(manager);
}






